<?php

use EventPortal\Domain\Delegate\Models\Delegate;
use EventPortal\Domain\Delegate\Models\DelegateFormData;
use EventPortal\Domain\Event\Form\Models\FormStep;
use EventPortal\Domain\Event\Form\Models\Question;
use Faker\Generator as Faker;

/** @var \Illuminate\Database\Eloquent\Factory $factory */
$factory->define(DelegateFormData::class, static function (Faker $faker): array {
    return [
        'delegate_id' => static function (): int {
            return factory(Delegate::class)->create()->id;
        },
        'form_step_id' => static function (): int {
            return factory(FormStep::class)->create()->id;
        },
        'question_id' => static function (): int {
            return factory(Question::class)->create()->id;
        },
        'value' => $faker->sentence(3),
    ];
});
