<?php

use EventPortal\Domain\Component\Button;
use EventPortal\Domain\Component\Display;
use EventPortal\Domain\Component\Input\Password;
use EventPortal\Domain\Component\Section;
use EventPortal\Domain\Delegate\Handlers\UpdatePassword;
use EventPortal\Domain\Form\Facades\Form;
use EventPortal\Enums\InertiaMethod;

Form::make('delegate.account.show')
    ->addFields(function () {
        return [
            Section::make()->fields([
                Display::make('First name'),
                Display::make('Last name'),
                Display::make('Type'),
                Display::make('Email'),
                Display::make('PA email')->name('pa_email'),
            ]),
        ];
    });

Form::make('delegate.account.password.edit')
    ->addHandler(new UpdatePassword)
    ->addFields(function () {
        return [
            Section::make('')->fields([
                Password::make('Current password')->rules(['required', 'password']),
            ]),
            Section::make('')->fields([
                Password::make('New password')
                    ->rules(config('auth-password.validation.password'))
                    ->name('password')
                    ->value(''),
                Password::make('Confirm password')->name('password_confirmation')->rules(['required']),
            ]),
        ];
    })
    ->addPrimaryAction(function () {
        return Button::make('Update password')
            ->variant('primary')
            ->method(InertiaMethod::POST())
            ->route('account.password.update');
    });
