<?php

namespace EventPortal\Http\Middleware\Event;

use Closure;
use EventPortal\Contracts\Event;
use EventPortal\Domain\Approval\Models\Approval;
use Illuminate\Http\Request;

class IsEventApproved
{
    private const APPROVED_STATUS = 'approved';

    /**
     * @return mixed
     */
    public function handle(Request $request, Closure $next)
    {
        if ($this->isEventAlreadyApproved($request->event)) {
            return redirect()->route('admin.dashboard.index');
        }

        return $next($request);
    }

    private function isEventAlreadyApproved(Event $event): bool
    {
        $approval = $event->approval()->first();

        if (!$approval instanceof Approval) {
            return false;
        }

        return $approval->status === self::APPROVED_STATUS;
    }
}
