<?php

namespace EventPortal\Tests\Unit\Event\Form\Models;

use EventPortal\Domain\Event\Form\Models\FormStepSection;
use EventPortal\Domain\Event\Form\Models\Question;
use EventPortal\Domain\Event\Form\Models\QuestionOption;
use EventPortal\Domain\Event\Form\Models\QuestionValidation;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\RefreshDatabase;

class FormStepSectionTest extends TestCase
{
    use RefreshDatabase;

    /** @test **/
    public function deletes_questions_options_validations_when_deleting_section(): void
    {
        $section = factory(FormStepSection::class)->create();
        $question = factory(Question::class)->create(['form_step_section_id' => $section->id]);
        factory(QuestionOption::class)->create(['question_id' => $question->id]);
        factory(QuestionValidation::class)->create(['question_id' => $question->id]);

        $section->delete();

        $this->assertCount(0, FormStepSection::all());
        $this->assertCount(0, Question::all());
        $this->assertCount(0, QuestionOption::all());
        $this->assertCount(0, QuestionValidation::all());
    }
}
